################################################################################################
#
#                                         Secret Doors 3
#
################################################################################################


################################################################# General ################################################################

execute as @a[tag=give] at @s run function secret_doors:give
tag @a remove give


scoreboard players set @a[y_rotation=-45..45] p_rot 1
scoreboard players set @a[y_rotation=46..135] p_rot 2
scoreboard players set @a[y_rotation=135..180] p_rot 3
scoreboard players set @a[y_rotation=-180..-135] p_rot 3
scoreboard players set @a[y_rotation=-134..-46] p_rot 4

##############################################################################################  Ladder Chest ##################################################################################################

execute as @e[type=item,nbt={Item:{id:"minecraft:chest"},OnGround:1b}] at @s run execute as @e[type=item,nbt={Item:{id:"minecraft:ladder"},OnGround:1b},distance=..0.8] at @s run function secret_doors:ladder_chest/spawn_spawn_egg
execute as @e[type=armor_stand,tag=sp_lc] at @s run function secret_doors:ladder_chest/ladder_chest_spawn
execute as @e[type=armor_stand,tag=ladder_chest] at @s if block ~ ~-1 ~ #secret_doors:air run function secret_doors:ladder_chest/ladder_chest_kill
execute as @e[type=armor_stand,tag=ladder_chest,scores={lc_open=0}] at @s if block ~ ~ ~ #secret_doors:air run function secret_doors:ladder_chest/ladder_chest_kill

execute as @a[scores={talk=1..}] at @s positioned ^ ^ ^2 run tag @e[type=armor_stand,tag=ladder_chest,distance=..5,limit=1,sort=nearest] add lc_click
execute as @e[type=armor_stand,tag=ladder_chest,tag=lc_click] at @s run function secret_doors:ladder_chest/ladder_chest_click
execute as @e[type=armor_stand,tag=ladder_chest,scores={lc_open=-11..-1}] run function secret_doors:ladder_chest/ladder_chest_tick
execute as @e[type=armor_stand,tag=ladder_chest,scores={lc_open=1..9}] run function secret_doors:ladder_chest/ladder_chest_tick

##############################################################################################  Tree Door ##################################################################################################

execute as @e[type=armor_stand,tag=sp_td] at @s run function secret_doors:tree_door/attempt_tree_door_spawn
execute as @e[type=armor_stand,tag=tree_door] at @s if block ~ ~-1 ~ #secret_doors:air run function secret_doors:tree_door/tree_door_kill
execute as @e[type=armor_stand,tag=tree_door_comp,scores={tdc_timer=1..}] at @s run function secret_doors:tree_door/component_timer
execute as @e[type=armor_stand,tag=tree_door,scores={td_finish_timer=1..}] at @s run function secret_doors:tree_door/finish_timer
execute as @e[type=armor_stand,tag=tree_door,scores={td_mopen_timer=1..}] at @s run function secret_doors:tree_door/manual_open_timer
execute as @e[type=armor_stand,tag=tree_door,scores={td_seq_timer=1..}] at @s run function secret_doors:tree_door/sequence_timer

execute as @e[type=armor_stand,tag=tree_door,scores={td_finish_timer=0,td_mopen_timer=0}] at @s positioned ~ ~-1.5 ~ if entity @a[distance=..0.42] run scoreboard players set @s td_mopen_timer 1

execute as @a[scores={talk=1..}] at @s positioned ^ ^ ^2 run execute as @e[tag=tree_door_comp,distance=..2,tag=td_active,scores={tdc_timer=0},limit=1,sort=nearest] at @s run function secret_doors:tree_door/click_component



##############################################################################################  Stone Wall ##################################################################################################

execute as @e[type=armor_stand,tag=sp_sw] at @s run function secret_doors:stone_wall/attempt_stone_wall_spawn
execute as @e[type=armor_stand,tag=stone_wall] at @s if block ~ ~-1 ~ #secret_doors:air run function secret_doors:stone_wall/stone_wall_kill

execute as @e[type=armor_stand,tag=stone_wall,scores={sw_open=1..}] at @s run function secret_doors:stone_wall/open_timer

execute as @e[type=armor_stand,tag=stone_wall] at @s if entity @e[type=item,nbt={Item:{id:"minecraft:tnt",Count:64b},OnGround:1b},distance=..2] run function secret_doors:stone_wall/stone_wall_kill

execute as @e[type=armor_stand,tag=stone_wall,tag=sw_rot_z,scores={sw_open=0}] at @s if entity @a[nbt={SelectedItem:{id:"minecraft:nether_star"}},distance=..25] run particle minecraft:enchant ~ ~1.5 ~ 0.35 0.8 0.8 0.1 5 force
execute as @e[type=armor_stand,tag=stone_wall,tag=sw_rot_x,scores={sw_open=0}] at @s if entity @a[nbt={SelectedItem:{id:"minecraft:nether_star"}},distance=..25] run particle minecraft:enchant ~ ~1.5 ~ 0.8 0.8 0.35 0.1 5 force


execute as @e[type=armor_stand,tag=stone_wall,scores={sw_open=0}] at @s positioned ^ ^1 ^-5 if entity @a[nbt={RootVehicle:{Entity:{id:"minecraft:minecart"}},SelectedItem:{id:"minecraft:nether_star"}},distance=..5] run scoreboard players set @s sw_open 1


##############################################################################################  Decoy Door ##################################################################################################

function special_door:tick

execute as @e[type=armor_stand,tag=incomplete_dd] at @s run execute as @a[nbt={SelectedItem:{id:"minecraft:vex_spawn_egg",tag:{CustomModelData:4}}},distance=..50] at @s run title @s actionbar {"text":"Place the 2nd entrance!","color":"dark_blue"}
execute as @e[type=armor_stand,tag=incomplete_dd] at @s run execute as @a[nbt={SelectedItem:{id:"minecraft:vex_spawn_egg",tag:{CustomModelData:4}}},distance=..50] at @s run tag @e[tag=sp_sd] add sp_sds
execute as @e[type=armor_stand,tag=incomplete_dd] at @s run execute as @a[nbt={SelectedItem:{id:"minecraft:vex_spawn_egg",tag:{CustomModelData:4}}},distance=..50] at @s run tag @e[tag=sp_sd] remove sp_sd
execute as @e[type=armor_stand,tag=sp_sds] at @s run function secret_doors:special_door/special_door_spawn_stone
execute as @e[type=armor_stand,tag=sp_sd] at @s run function secret_doors:special_door/attempt_special_door_spawn
execute as @e[type=armor_stand,tag=special_door,scores={sd_timer=0}] at @s if entity @e[type=item,nbt={Item:{id:"minecraft:tnt",Count:64b},OnGround:1b},distance=..2] run function secret_doors:special_door/special_door_kill
execute as @e[type=armor_stand,tag=special_door,scores={sd_timer=301}] at @s if entity @e[type=item,nbt={Item:{id:"minecraft:tnt",Count:64b},OnGround:1b},distance=..2] run function secret_doors:special_door/special_door_kill

execute as @a[scores={talk=1..}] at @s positioned ^ ^ ^2 run tag @e[type=armor_stand,tag=special_door,distance=..4,limit=1,sort=nearest] add sd_click

scoreboard players set @e[type=armor_stand,tag=sd_click,scores={sd_timer=0}] sd_timer 1
scoreboard players set @e[type=armor_stand,tag=sd_click,scores={sd_timer=301}] sd_timer -300
tag @e[type=armor_stand,tag=sd_click] remove sd_click

execute as @e[type=armor_stand,tag=special_door,scores={sd_timer=1..300}] at @s run function secret_doors:special_door/special_door_timer
execute as @e[type=armor_stand,tag=special_door,scores={sd_timer=-300..-1}] at @s run function secret_doors:special_door/special_door_timer

execute as @e[type=armor_stand,tag=special_door_stone,scores={stone_door_timer=1..300}] at @s run function secret_doors:special_door/stone_door_timer
execute as @e[type=armor_stand,tag=special_door_stone,scores={stone_door_timer=-300..-1}] at @s run function secret_doors:special_door/stone_door_timer



##############################################################################################  Bed Door ##################################################################################################


execute as @e[type=armor_stand,tag=bd_sd] at @s run function secret_doors:bed_door/attempt_bed_door_spawn

execute as @a[scores={talk=1..}] at @s positioned ^ ^ ^2.5 run tag @e[type=armor_stand,tag=bed_door,distance=..3,limit=1,sort=nearest] add bd_click

scoreboard players set @e[type=armor_stand,tag=bd_click,scores={bed_door_timer=0}] bed_door_timer 1
scoreboard players set @e[type=armor_stand,tag=bd_click,scores={bed_door_timer=31}] bed_door_timer -30
tag @e[type=armor_stand,tag=bd_click] remove bd_click

execute as @e[type=armor_stand,tag=bed_door,scores={bed_door_timer=1..30}] at @s run function secret_doors:bed_door/bed_door_timer
execute as @e[type=armor_stand,tag=bed_door,scores={bed_door_timer=-30..-1}] at @s run function secret_doors:bed_door/bed_door_timer

execute as @e[type=armor_stand,tag=bed_door,scores={bed_door_timer=31}] at @s if entity @e[type=item,nbt={Item:{id:"minecraft:tnt",Count:64b},OnGround:1b},distance=..2.5] run function secret_doors:bed_door/bed_door_kill
execute as @e[type=armor_stand,tag=bed_door,scores={bed_door_timer=0}] at @s if entity @e[type=item,nbt={Item:{id:"minecraft:tnt",Count:64b},OnGround:1b},distance=..2.5] run function secret_doors:bed_door/bed_door_kill



##############################################################################################  Heart Door ##################################################################################################


execute store result score @s foodLevel run data get entity @s foodLevel
execute as @s[scores={foodLevel=..19}] run function unkillable:hunger_message

tag @a remove 1heart
tag @a[scores={pHealth=2}] add 1heart

execute as @e[type=armor_stand,tag=sp_hd] at @s run function secret_doors:heart_door/attempt_heart_door_spawn

execute as @e[type=armor_stand,tag=heart_door,scores={heart_door_timer=1..40}] at @s run function secret_doors:heart_door/heart_door_timer
execute as @e[type=armor_stand,tag=heart_door,scores={heart_door_timer=-40..-1}] at @s run function secret_doors:heart_door/heart_door_timer

execute as @e[type=armor_stand,tag=heart_door] at @s if entity @a[tag=1heart,distance=..5] run scoreboard players set @s[scores={heart_door_timer=0}] heart_door_timer 1
execute as @e[type=armor_stand,tag=heart_door] at @s unless entity @a[tag=1heart,distance=..5] run scoreboard players set @s[scores={heart_door_timer=41}] heart_door_timer -40

execute as @e[type=armor_stand,tag=heart_door] at @s positioned ^ ^ ^0.5 unless entity @a[tag=1heart,distance=..5] if entity @a[tag=!1heart,distance=..2.5] run effect give @e[tag=heart_door_outline,limit=1,sort=nearest] glowing 1 1 true

execute as @e[type=armor_stand,tag=heart_door,scores={heart_door_timer=41}] at @s if entity @e[type=item,nbt={Item:{id:"minecraft:tnt",Count:64b},OnGround:1b},distance=..2.5] run function secret_doors:heart_door/heart_door_kill
execute as @e[type=armor_stand,tag=heart_door,scores={heart_door_timer=0}] at @s if entity @e[type=item,nbt={Item:{id:"minecraft:tnt",Count:64b},OnGround:1b},distance=..2.5] run function secret_doors:heart_door/heart_door_kill


################################################################################################################################################################################################

effect give @e[tag=invis] invisibility 1 1 true
scoreboard players set @a rc 0
scoreboard players set @a sneak 0
scoreboard players set @a talk 0
